/*
** Module   : DynamicOps.java
** Abstract : operators and functions that have dynamic type behavior
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- --------------------------------Description---------------------------------
** 001 GES 20130301 Created the initial version with support for a version of the plus operator
**                  which dyanmically handles its return type based on its operands.
*/

package com.goldencode.p2j.util;

/**
 * A class that provides Progress 4GL compatible operators and functions that have dynamic
 * type behavior. This class provides all functionality as statics and has no instance data.
 */
public final class DynamicOps
{
   /**
    * Implements the binary plus operator whose result will differ based on the types of the
    * operands, which will not be known until runtime.
    * <p>
    * If either operand is the <code>unknown value</code>, the result will
    * be the <code>unknown value</code>.
    *
    * @param    op1
    *           The left operand.
    * @param    op2
    *           The right operand.
    *
    * @return   The dynamically determined result.
    */
   public static BaseDataType plus(BaseDataType op1, BaseDataType op2)
   {
      return null;
   }
}
